<?php
/*
Plugin Name: Daily Crowdsource News
Plugin URI: http://dailycrowdsource.com/
Description: Show the hottest crowdsourcing news headlines on your site
Version: 1.0.7
Author: The Daily Crowdsource
Author URI: http://dailycrowdsource.com
License: GPL
*/

class Daily_Crowdsource_Headlines extends WP_Widget {
	// The widget construct. Mumbo-jumbo that loads our code.
    function Daily_Crowdsource_Headlines() {
        $widget_ops = array( 'classname' => 'widget_DCHeadlines', 'description' => __( "Show the latest/top crowdsourcing headlines on your site" ) );
        $this->WP_Widget('DCHeadlines', __('Daily Crowdsource News'), $widget_ops);
    } // End function 
    
	// This code displays the widget on the screen.
    function widget($args, $instance) {
        $tdoffsite = 1;                             //For internal testing, set to 0
        if(!is_home() || $tdoffsite){
            extract($args);
            echo $before_widget;
            if(!empty($instance['title'])) { 
                echo $before_title . $instance['title'] . $after_title; 
            }
            $dcgear = WP_PLUGIN_URL.'/'.plugin_basename(dirname(__FILE__)).'/get-widget.png';
            require_once('wp-includes/class-simplepie.php');
            $feed = new SimplePie();
            $feed->set_feed_url('http://feeds.feedburner.com/TheDailyCrowdsource');
            if($instance['dcnocache']){ $feed->enable_cache(false); }
            $feed->set_cache_location('wp-content/cache');
            $feed->init();
            $feed->handle_content_type(); ?>
            <!-- Daily Crowdsource News v 1.0.7 -->
            <div class="dcheadlines <?php echo $instance['dcgui'];?>"><?php echo $before_title;?><a href="http://dailycrowdsource.com/" target="_tdext" alt="#1 site for crowdsourcing news | The Daily Crowdsource" title="#1 site for crowdsourcing news | The Daily Crowdsource">Daily Crowdsource Headlines</a><?php echo $after_title;?>
                <ul>    
                    <?php foreach($feed->get_items(0,$instance['dcqty']) as $item):
                        $permalink = $item->get_permalink();
                        $permatitle = $item->get_title();?>
                        <li class="dcitem">
                            <div class="dcline1">
                                <a href="<?php echo $permalink;?>" target="_tdext" alt="<?php echo $permatitle;?>"><img src="<?php echo urldecode(DCHeadlineImage($item->get_content()));?>" alt="<?php echo $permatitle;?>" class="dcsplash" />
                                    <span class="dcnews">
                                        <?php echo $permatitle;?>
                                    </span>
                                </a>
                            </div>
                            <?php if($instance['dcshare'] == 'dcbothxfbml' || $instance['dcshare'] == 'dcbothiframe' || $instance['dcshare'] == 'dcfacexfbml' || $instance['dcshare'] == 'dcfaceiframe'):?>
                                <span class="dclike">
                                    <?php if($instance['dcshare'] == 'dcbothxfbml' || $instance['dcshare'] == 'dcfacexfbml'): ?>
                                        <script src="http://connect.facebook.net/en_US/all.js#xfbml=1"></script><fb:like href="<?php echo $permalink;?>" layout="button_count" show_faces="false" width="100"></fb:like>
                                    <?php else: ?>
                                        <iframe src="http://www.facebook.com/plugins/like.php?href=<?php echo $permalink;?>&amp;layout=button_count&amp;show_faces=false&amp;width=100&amp;action=like&amp;colorscheme=light&amp;height=21" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:100px; height:21px;" allowTransparency="true"></iframe>
                                    <?php endif;?>
                                </span>
                            <?php endif; ?>
                            <?php if($instance['dcshare'] == 'dcbothxfbml' || $instance['dcshare'] == 'dcbothiframe' || $instance['dcshare'] == 'dctwit'):?>
                                <span class="dctweet">
                                    <a href="http://twitter.com/share" class="twitter-share-button" data-url="<?php echo $permalink;?>" data-text="<?php echo $permatitle;?>" data-count="horizontal" data-via="<?php echo $instance['dctuname'];?>" data-related="TDCrowdsource:#1 site for crowdsourcing news">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>
                                </span>
                            <?php endif; ?>
                            <div style="clear:both;"></div>
                            <em><?php echo DCdoRelativeDate($item->get_date(YmdHis));?></em>
                        </li>
                    <?php endforeach; ?>
                </ul>
                <?php if($tdoffsite): ?>
                    <div class="dcreadmore"><a href="http://dailycrowdsource.com/" target="_tdext" alt="#1 site for crowdsourcing news | The Daily Crowdsource" title="#1 site for crowdsourcing news | The Daily Crowdsource">Read more </a><a href="http://dailycrowdsource.com/what-is-crowdsourcing/" target="_tdext" alt="What is crowdsourcing" title="What is crowdsourcing">crowdsourcing</a><a href="http://dailycrowdsource.com/" target="_tdext" alt="#1 site for crowdsourcing news | The Daily Crowdsource" title="#1 site for crowdsourcing news | The Daily Crowdsource"> news</a>
                    <a href="http://dailycrowdsource.com/crowdsourcing-tools/news-widget/" target="_tdext" alt="Get The Daily Crowsource Headlines WordPress Widget" title="Get this Widget"><img src="<?php echo $dcgear;?>" class="dcgear" alt="Get The Daily Crowsource Headlines WordPress Widget" title="Get this Widget" width="14" height="14" /></a></div>
                <?php else: ?>
                    <a href="http://dailycrowdsource.com/crowdsourcing-widgets/news-widget/" alt="Get The Daily Crowsource Headlines WordPress Widget" title="Get this Widget"><img src="http://crowdsourcedaily.com/wp-content/themes/Revize/images/get-daily-crowdsource-crowdsourcing-widget.jpg" alt="Get The Daily Crowsource Headlines WordPress Widget" title="Get this Widget" /></a>
                <?php endif;?>
            </div>  <?php
            echo $after_widget;
        }
    } // End function widget.
    
	// Updates the settings.
    function update($new_instance, $old_instance) {
        return $new_instance;
    } // End function update 
    
	// The admin form.
    function form($instance) {		?>
        <div id="DCHeadlines-admin-panel">
            <p>
                <label for="<?php echo $this->get_field_id("dcqty");?>">Headlines to show:</label>
                <input type="text" name="<?php echo $this->get_field_name("dcqty");?>" id="<?php echo $this->get_field_id("dcqty");?>" size="3" value="<?php echo $instance["dcqty"];?>" />
            </p>
            <p>
                <label for="<?php echo $this->get_field_id('dcgui'); ?>"><?php _e('Style:'); ?> 
                <select id="<?php echo $this->get_field_id('dcgui'); ?>" name="<?php echo $this->get_field_name('dcgui'); ?>" >
                    <option value="dcgraphical" <?php if( $instance['dcgui'] == 'dcgraphical' ) echo 'selected="selected"'; ?> ><?php _e('Graphical'); ?></option>
                    <option value="dclist" <?php if( $instance['dcgui'] == 'dclist' ) echo 'selected="selected"'; ?> ><?php _e('List'); ?></option>
                </select>
            </p>
            <p>
                <label for="<?php echo $this->get_field_id('dcshare'); ?>"><?php _e('Share Buttons:'); ?> 
                <select id="<?php echo $this->get_field_id('dcshare'); ?>" name="<?php echo $this->get_field_name('dcshare'); ?>" >
                    <option value="dcbothxfbml" <?php if( $instance['dcshare'] == 'dcbothxfbml' ) echo 'selected="selected"'; ?> ><?php _e('Twitter & Facebook(xfbml)'); ?></option>
                    <option value="dcbothiframe" <?php if( $instance['dcshare'] == 'dcbothiframe' ) echo 'selected="selected"'; ?> ><?php _e('Twitter & Facebook(iframe)'); ?></option>
                    <option value="dctwit" <?php if( $instance['dcshare'] == 'dctwit' ) echo 'selected="selected"'; ?> ><?php _e('Twitter Only'); ?></option>
                    <option value="dcfacexfbml" <?php if( $instance['dcshare'] == 'dcfacexfbml' ) echo 'selected="selected"'; ?> ><?php _e('Facebook Only(xfbml)'); ?></option>
                    <option value="dcfaceiframe" <?php if( $instance['dcshare'] == 'dcfaceiframe' ) echo 'selected="selected"'; ?> ><?php _e('Facebook Only(iframe)'); ?></option>
                    <option value="dcnone" <?php if( $instance['dcshare'] == 'dcnone' ) echo 'selected="selected"'; ?> ><?php _e('None'); ?></option>
                </select>
            </p>
            <p>
                <label for="<?php echo $this->get_field_id("dctuname");?>">Twitter Username:</label>
                <input type="text" name="<?php echo $this->get_field_name("dctuname");?>" id="<?php echo $this->get_field_id("dctuname");?>" value="<?php echo $instance["dctuname"];?>" />
            </p>
            <p>Cache Errors? <a href="http://dailycrowdsource.com/crowdsourcing-tools/news-widget/wordpress/cache-settings/" target="_tdext">How to fix</a>.<br />
            Disable cache <input type="checkbox" name="<?php echo $this->get_field_name("dcnocache");?>" id="<?php echo $this->get_field_id("dcnocache");?>" value="1" <?php if($instance['dcnocache']) echo 'checked="checked"'; ?> /><br />
            Not recommended. <a href="http://dailycrowdsource.com/crowdsourcing-tools/news-widget/wordpress/cache-settings/" target="_tdext">What it will do</a>.</p>
        </div>  <?php
    } // end function form
}


function DCHeadlineImage($text) {
    $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
    //echo $text;
    $pattern = "/<img[^>]+\>/i";
    preg_match($pattern, $text, $matches);
    $text = $matches[0];
    
    $pattern = '/src=[\'"]?([^\'" >]+)[\'" >]/';     
    preg_match($pattern, $text, $link);

    $link = $link[1];
    $link = urlencode($link);
    return $link;

}

function DCdoRelativeDate($posted_date) {
    /**
        This function returns either a relative date or a formatted date depending
        on the difference between the current datetime and the datetime passed.
            $posted_date should be in the following format: YYYYMMDDHHMMSS
        Relative dates look something like this:
            3 weeks, 4 days ago
        Formatted dates look like this:
            on 02/18/2004
        The function includes 'ago' or 'on' and assumes you'll properly add a word
        like 'Posted ' before the function output.
        By Garrett Murray, http://graveyard.maniacalrage.net/etc/relative/
    **/
    $in_seconds = strtotime(substr($posted_date,0,8).' '.
                  substr($posted_date,8,2).':'.
                  substr($posted_date,10,2).':'.
                  substr($posted_date,12,2));
    $diff = time()-$in_seconds;
    $months = floor($diff/2592000);
    $diff -= $months*2419200;
    $weeks = floor($diff/604800);
    $diff -= $weeks*604800;
    $days = floor($diff/86400);
    $diff -= $days*86400;
    $hours = floor($diff/3600);
    $diff -= $hours*3600;
    $minutes = floor($diff/60);
    $diff -= $minutes*60;
    $seconds = $diff;
 
    if ($months>0) {
        // over a month old, just show date (mm/dd/yyyy format)
        return 'on '.substr($posted_date,4,2).'/'.substr($posted_date,6,2).'/'.substr($posted_date,0,4);
    } else {
        if ($weeks>0) {
            // weeks and days
            $relative_date .= ($relative_date?', ':'').$weeks.' week'.($weeks>1?'s':'');
        } elseif ($days>0) {
            // days and hours
            $relative_date .= ($relative_date?', ':'').$days.' day'.($days>1?'s':'');
        } elseif ($hours>0) {
            // hours and minutes
            $relative_date .= ($relative_date?', ':'').$hours.' hour'.($hours>1?'s':'');
        } elseif ($minutes>0) {
            // minutes only
            $relative_date .= ($relative_date?', ':'').$minutes.' minute'.($minutes>1?'s':'');
        } else {
            // seconds only
            $relative_date .= ($relative_date?', ':'').$seconds.' second'.($seconds>1?'s':'');
        }
    }
    // show relative date and add proper verbiage
    return $relative_date.' ago';
}


function DCadd_my_stylesheet() {
    $myStyleUrl = WP_PLUGIN_URL.'/'.plugin_basename(dirname(__FILE__)).'/style.css';
    $myStyleFile = WP_PLUGIN_DIR.'/'.plugin_basename(dirname(__FILE__)).'/style.css';
    if ( file_exists($myStyleFile) ) {
        wp_register_style('DailyCrowdsourceNewsCSS', $myStyleUrl);
        wp_enqueue_style( 'DailyCrowdsourceNewsCSS');
    }
}
    
add_action('wp_print_styles', 'DCadd_my_stylesheet');
add_action('widgets_init', create_function('', 'return register_widget("Daily_Crowdsource_Headlines");'));
?>